CreateTab proto :DWORD
TABAddTab proto :DWORD, :DWORD
TABRenTab proto 
TABDelTab proto 
TABSetSel proto :DWORD
TABGetSel proto
TABCreateBrushesAndFonts proto
TABDeleteBrushesAndFonts proto
TABCreatePopupMenu proto
TABCreateChildWindows proto
TABEditWndProc proto :DWORD, :DWORD, :DWORD, :DWORD
TABWndProc proto :DWORD, :DWORD, :DWORD, :DWORD
TABPaint proto
TABDelAll proto
TABSetDefaultFlags proto
TABToolTipNeedText proto :DWORD


TABSTRUCT32 STRUCT
	;master info
	masterhwnd	dd	?
	hWnd		dd	?
	hInstance	dd	?
	hToolTip	dd	?
	hEdit		dd	?
	EditFlag	dd	?
	EditOldWndProc dd ?
	hCursor		dd	?
	hMenu		dd	?
	
	;tab info
	gentabcount	dd	?
	counter		dd	?
	tabminwidth	dd	?
	tablenght	dd	?
	tabheight	dd	?
	
	;brushes etc
	hBrush		dd	?
	hBlackPen	dd	?
	hLightGrayBrush	dd	?
	hGrayPen	dd	?
	hTahoma		dd	?
	hdc			dd	?
	SelDC		dd	?
	UnSelDC		dd	?
	SelDCMask	dd	?
	UnSelDCMask	dd	?
	UnSelWidth	dd	?
	UnSelHeight	dd	?
	SelWidth	dd	?
	SelHeight	dd	?
	
	;Flags
	UserBrush	dd	?
	UserPen		dd	?
	UserFont	dd	?
	ToolTipsFlag dd ?
	vOrientation dd ?
	
	;Structures
	rect		RECT	<?>
TABSTRUCT32 ends

;	id 		- My id (always increasing)
;	udata 	- User defined variable
;	lpsz	- string for Tab and Tooltip
TABINFO STRUCT				; s$ == 60
	id		dd	?			; 0
	udata	dd	?			; 4
	lpsz	db 48 dup (?)	; 8
TABINFO ends

a$	TEXTEQU	<ADDR>
b$	TEXTEQU	<BYTE PTR>
d$	TEXTEQU	<DWORD PTR>
w$	TEXTEQU	<WORD PTR>
s$	TEXTEQU	<SIZEOF>
PT	TEXTEQU	<PrintText>
PD	TEXTEQU	<PrintDec>
PH	TEXTEQU	<PrintHex>
PTA	TEXTEQU	<PrintStringByAddr>


.const
TAB_ADDSELIMAGEMASK		equ	WM_USER + 340
TAB_ADDUNSELIMAGEMASK	equ	WM_USER + 341
TAB_ENABLETOOLTIPS		equ	WM_USER + 342
TAB_GETMENUHANDLE		equ	WM_USER + 343	; user can play with the menu a bit
TAB_TABADDED			equ	WM_USER + 344	; we send this message when we add a new tab thru the menu
TAB_ADDUSERDATA			equ	WM_USER + 345	; add some user data to tab (which we send back upon changing tabs
TAB_SETFONT				equ	WM_USER + 346	; user wants to use his own font to write
TAB_SETBRUSHES			equ	WM_USER + 347	; user wants to use his own brushes to paint
TAB_SETPENS				equ	WM_USER + 348	; user wants to use his own pens to write
TAB_WIDTHHEIGHT			equ	WM_USER + 349	; send by user to set Tabheight and lenght
TAB_ADDTAB				equ	WM_USER + 350	; lParam pointer to text || if lParam == 0 --> "New Tab"
TAB_RENTAB				equ	WM_USER + 351	; lParam pointer to text || if lParam == 0 --> create edit field **
TAB_DELTAB				equ	WM_USER + 352	; lParam == Nr of Tab	|| if lParam == 0 --> delcursel
TAB_SELCHANGED			equ	WM_USER + 354	; Send to user to inform we changed tabs
TAB_GETCOUNT			equ	WM_USER + 355	; no params rets no of tabs
TAB_DELALL				equ	WM_USER + 356	; no params.. dels all tabs
TAB_SETSEL				equ	WM_USER + 357	; lParam --> no of item
TAB_GETSEL				equ	WM_USER + 358	; returns no of selected item
TAB_ADDSELIMAGE			equ	WM_USER + 359	; pass 16x16 bmp handle
TAB_ADDUNSELIMAGE		equ	WM_USER + 360	; idem
TAB_REMSELIMAGE			equ	WM_USER + 361	; no params
TAB_REMUNSELIMAGE		equ	WM_USER + 362	; no params
TAB_COMMAND1			equ	WM_USER + 363	; user playground to add menuitems
TAB_COMMAND2			equ	WM_USER + 364	; """"""""""""""""""""""""""""""""
TAB_COMMAND3			equ	WM_USER + 365	; """"""""""""""""""""""""""""""""
TAB_COMMAND4			equ	WM_USER + 366	; """"""""""""""""""""""""""""""""
TAB_COMMAND5			equ	WM_USER + 367	; """"""""""""""""""""""""""""""""
TAB_COMMAND6			equ	WM_USER + 368	; """"""""""""""""""""""""""""""""
TAB_COMMAND7			equ	WM_USER + 369	; """"""""""""""""""""""""""""""""
TAB_COMMAND8			equ	WM_USER + 370	; """"""""""""""""""""""""""""""""
TAB_COMMAND9			equ	WM_USER + 371	; """"""""""""""""""""""""""""""""
TAB_COMMAND10			equ	WM_USER + 372	; """"""""""""""""""""""""""""""""
TABERR_STRTOOLONG		equ	145				; string is too long..
TABERR_MAXTABSALLOWED	equ	146				; no more than 40 Tabs... don't be crazy
IDTOOLTIP 				equ 500				; blah

.data
tab_ClassName		db	"Tab32Control",0
ToolTipClassName	db	"tooltips_class32",0
ALIGN 4
; --- Fonts and such (This is Tahoma - Size 8)
TabFont				db	0F5h,		0FFh,	0FFh,	0FFh,	0,			0,			0,			0
					dd	0,0	
					db	090h,		01h,	0,		0,		0,			0,			0,			0
					db	03h,		02h,	01h,	022h,	054h,		061h,		068h,		06Fh
					db	06Dh,		061h,	0,		0,		0FFh,		0FFh,		0FFh,		0FFh
					db	05Ch,		0EEh,	063h,	0,		0FFh,		0FFh,		0FFh,		0FFh
					db	0Ch,		0EEh,	063h,	0,		04Eh,		064h,		0F4h,		0BFh
					db 	09h,		04h,	0,		0,		0,			0,			0,			0


.data?
ALIGN 4
tab			TABSTRUCT32 <?>
tabinfos	db  41*60 dup (?)	;40 Tabs - 1 empty
tabpos		db	64 dup (?)		;what pos is the tab ?
tabactive	db	64 dup (?)		;is the tab active ?
tabBuffer	db	128 dup (?)
ti			TOOLINFO <?>

.code

CreateTab proc hwnd:DWORD
 LOCAL wc:WNDCLASSEX
	
	m2m tab.masterhwnd, hwnd
	mov wc.cbSize, SIZEOF WNDCLASSEX
	mov wc.style,CS_HREDRAW+CS_VREDRAW
	mov wc.lpfnWndProc, offset TABWndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	invoke GetModuleHandle,NULL
	mov tab.hInstance,eax
	mov wc.hInstance,eax
	mov wc.hIcon,NULL
	invoke LoadCursor,0,IDC_ARROW
	mov tab.hCursor,eax
	mov wc.hCursor,eax
	mov wc.hbrBackground,COLOR_BACKGROUND	;NULL
	mov wc.lpszMenuName,NULL
	mov wc.lpszClassName, offset tab_ClassName
	mov wc.hIconSm,NULL
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,NULL,addr tab_ClassName,NULL,WS_CHILD+WS_VISIBLE,0,0,0,0,hwnd,NULL,tab.hInstance,NULL
	mov tab.hWnd,eax
	ret	; returns handle of Tab in eax for callers use
CreateTab endp

TABCreateChildWindows proc
	
	invoke CreateWindowEx,0,a$ ToolTipClassName,0,TTS_ALWAYSTIP,\
						CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,\
						tab.hWnd,0,tab.hInstance,0
	mov tab.hToolTip,eax
	invoke CreateWindowEx,WS_EX_TRANSPARENT,CTXT("EDIT"),0,WS_CHILD or ES_AUTOHSCROLL,0,0,0,0,tab.hWnd,0,tab.hInstance,0
	mov tab.hEdit,eax
	invoke SetWindowLong,tab.hEdit,GWL_WNDPROC,addr TABEditWndProc
	mov tab.EditOldWndProc,eax
	invoke SendMessage,tab.hEdit,WM_SETFONT,tab.hTahoma,FALSE
	invoke SendMessage,tab.hEdit,EM_LIMITTEXT,30,0
	ret
TABCreateChildWindows endp

TABCreatePopupMenu proc
	
	invoke CreatePopupMenu
	mov tab.hMenu,eax
	invoke AppendMenu,tab.hMenu,MF_STRING,TAB_ADDTAB,CTXT("Add Tab")
	invoke AppendMenu,tab.hMenu,MF_STRING,TAB_RENTAB,CTXT("Rename Tab")
	invoke AppendMenu,tab.hMenu,MF_STRING,TAB_DELTAB,CTXT("Delete Tab")
	ret
TABCreatePopupMenu endp

TABSetDefaultFlags proc
	
	mov tab.tablenght, 80	;default == 80
	mov tab.tabheight, 18	;default == 18
	mov tab.UserBrush, FALSE
	mov tab.UserPen, FALSE
	mov tab.UserFont,FALSE
	mov tab.ToolTipsFlag, TRUE
	mov tab.SelDC, 0
	mov tab.UnSelDC,0
	mov tab.SelDCMask,0
	mov tab.UnSelDCMask,0
	mov tab.EditFlag, -1	;Edit Window not in use (internal - gets id of Tab which we're editing)
	ret
TABSetDefaultFlags endp

TABWndProc proc uses ebx hwnd:DWORD, msg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL point:POINT
LOCAL ps:PAINTSTRUCT
	
	.IF !tab.hToolTip
		invoke SendMessage,tab.hToolTip,TTM_RELAYEVENT,0,a$ hwnd
	.ENDIF
	.IF msg == WM_CREATE
	; INITIALISATION
	;................................................................;DONE
		invoke InitCommonControls
		
		mov tab.hInstance, $invoke(GetModuleHandle,0)
		m2m tab.hWnd,hwnd
		
		invoke TABCreateBrushesAndFonts
		invoke TABCreatePopupMenu
		invoke TABCreateChildWindows
		invoke TABSetDefaultFlags

	;................................................................
	; USER SENT MESSAGES
	;................................................................
	.ELSEIF msg == TAB_GETMENUHANDLE								;DONE
		return tab.hMenu
	.ELSEIF msg == TAB_ENABLETOOLTIPS
		m2m tab.ToolTipsFlag, lParam
	;................................................................
	.ELSEIF msg == TAB_WIDTHHEIGHT									;DONE
		m2m tab.tablenght, lParam
		m2m tab.tabheight, wParam
	;................................................................
	.ELSEIF msg == TAB_GETCOUNT										;DONE
		return tab.gentabcount
	;................................................................
	.ELSEIF msg == TAB_SETSEL										;DONE
		;sets id active
		invoke TABSetSel, lParam
	;................................................................
	.ELSEIF msg == TAB_GETSEL										;DONE
		;returns id of sel tab
		invoke TABGetSel
		ret	;return to to caller
	;................................................................	
	.ELSEIF msg == TAB_SETBRUSHES		;inactive, active			;DONE
		invoke DeleteObject,tab.hBrush
		invoke DeleteObject,tab.hLightGrayBrush
		m2m tab.hBrush, wParam
		m2m tab.hLightGrayBrush, lParam
		mov tab.UserBrush, TRUE
	;................................................................
	.ELSEIF msg == TAB_SETPENS										;DONE
		invoke DeleteObject,tab.hBlackPen
		invoke DeleteObject,tab.hGrayPen
		m2m tab.hGrayPen, wParam
		m2m tab.hBlackPen, lParam
		mov tab.UserPen, TRUE
	;................................................................	
	.ELSEIF msg == TAB_SETFONT										;DONE
		invoke DeleteObject,tab.hTahoma
		m2m tab.hTahoma, lParam
		mov tab.UserFont,TRUE
	;................................................................
	.ELSEIF msg == TAB_ADDUSERDATA									;DONE
		mov eax, wParam
		imul eax, 60
		m2m d$ [tabinfos+eax+4],lParam

	;................................................................
	.ELSEIF msg == TAB_ADDTAB										;DONE
		invoke TABAddTab,wParam,lParam	; userdata, lpsz returns id of new tab
		.IF eax == TABERR_MAXTABSALLOWED
			ret	;returns error code to master
		.ENDIF
		; msg needs to be send cuz we can't add user data if tab gets created thru menu
		invoke SendMessage,tab.masterhwnd,TAB_TABADDED,0,eax
		invoke InvalidateRect,tab.hWnd,0,FALSE
	;................................................................
	.ELSEIF msg == TAB_RENTAB										;DONE
		invoke TABRenTab				;id creates edit control
	;................................................................
	.ELSEIF msg == TAB_DELTAB										
		invoke TABDelTab				;del active tab
	;................................................................
	.ELSEIF msg == TAB_DELALL			;dels all tabs				;DONE
		invoke TABDelAll
	;................................................................
	.ELSEIF msg == TAB_ADDSELIMAGE		;add bmp to the left		;DONE
		m2m tab.SelDC, lParam
		movzx eax, wParamL	;width
		movzx edx, wParamH	;height
		mov tab.SelWidth,eax
		mov tab.SelHeight,edx
	;................................................................
	.ELSEIF msg == TAB_ADDUNSELIMAGE	;add bmp to the left		;DONE
		m2m tab.UnSelDC, lParam
		movzx eax, wParamL	;width
		movzx edx, wParamH	;height
		mov tab.UnSelWidth,eax
		mov tab.UnSelHeight,edx
	;................................................................
	.ELSEIF msg == TAB_ADDUNSELIMAGEMASK							;DONE
		m2m tab.UnSelDCMask, lParam
	;................................................................
	.ELSEIF msg == TAB_ADDSELIMAGEMASK								;DONE
		m2m tab.SelDCMask, lParam
	;................................................................
	.ELSEIF msg == TAB_REMSELIMAGE		;remove bmp to the left		;DONE
		mov tab.SelDC,0
		mov tab.SelDCMask,0
	;................................................................	
	.ELSEIF msg == TAB_REMUNSELIMAGE	;remove bmp to the left		;DONE
		mov tab.UnSelDC,0
		mov tab.UnSelDCMask,0
		
		
	;................................................................	
	; INTERNAL MESSAGES
	;................................................................
	.ELSEIF msg == WM_CTLCOLOREDIT	;edit window background			;DONE
		invoke SetBkMode,wParam,TRANSPARENT
		return tab.hBrush
	;................................................................
	.ELSEIF msg == WM_PAINT											;DONE
		;paints the tabs
		invoke BeginPaint,hwnd,a$ ps
		mov tab.hdc,eax
		invoke TABPaint
		invoke EndPaint,hwnd,a$ ps
	;................................................................
	.ELSEIF msg == WM_LBUTTONDOWN									;DONE
		; destroys editfield if active
		.IF tab.EditFlag != -1
			mov tabBuffer[0],0
			invoke SendMessage,tab.hEdit,WM_GETTEXT,32, a$ tabBuffer
			.IF b$ tabBuffer != 0
				invoke TABGetSel
				imul eax,60
				lea edx, [tabinfos+eax+8]	;text of tabinfo+id
				mov d$ [edx],0
				invoke szCatStr, edx, a$ tabBuffer
			.ENDIF
			invoke ShowWindow,tab.hEdit,SW_HIDE
			invoke InvalidateRect,tab.hWnd,0,FALSE
			mov tab.EditFlag, -1
		.ENDIF
		; sets the clicked Tab active
		movsx eax, lParamL
		mov ecx, tab.tablenght
		xor edx,edx
		div ecx
		;eax got the tab number where user clicked
		.IF eax < tab.gentabcount
			invoke TABSetSel,eax
			invoke InvalidateRect,tab.hWnd,0,FALSE
		.ENDIF

	;................................................................
	.ELSEIF msg == WM_RBUTTONDOWN									;DONE
		; sets clicked Tab active
		; show a PopupMenu
		; destroys editfield if active
		.IF tab.EditFlag != -1
			mov tabBuffer[0],0
			invoke SendMessage,tab.hEdit,WM_GETTEXT,32, a$ tabBuffer
			.IF b$ tabBuffer != 0
				invoke TABGetSel
				imul eax,60
				lea edx, [tabinfos+eax+8]	;text of tabinfo+id
				mov d$ [edx],0
				invoke szCatStr, edx, a$ tabBuffer
			.ENDIF
			invoke ShowWindow,tab.hEdit,SW_HIDE
			invoke InvalidateRect,tab.hWnd,0,FALSE
			mov tab.EditFlag, -1
		.ENDIF
		movsx eax, lParamL
		mov ecx, tab.tablenght
		xor edx,edx
		div ecx
		;eax got the tab number where user clicked
		.IF eax < tab.gentabcount
			invoke TABSetSel,eax
			invoke InvalidateRect,tab.hWnd,0,FALSE
		.ENDIF
		movzx eax, lParamL
		movzx edx, lParamH
		mov point.x,eax
		mov point.y,edx
		invoke ClientToScreen,tab.hWnd,a$ point
		invoke TrackPopupMenu,tab.hMenu,TPM_CENTERALIGN or TPM_RIGHTBUTTON,point.x,point.y,0,tab.hWnd,0

	;................................................................
	.ELSEIF msg == WM_DESTROY										;DONE
		invoke TABDeleteBrushesAndFonts
		invoke DestroyMenu,tab.hMenu
        invoke PostQuitMessage,0
        
	;................................................................
	;WM_COMMAND
	;................................................................
	.ELSEIF msg == WM_COMMAND										;DONE
		mov eax, wParam
		.IF eax == TAB_ADDTAB
			invoke SendMessage,hwnd,TAB_ADDTAB,0,0
		.ELSEIF eax == TAB_RENTAB
			invoke TABRenTab
		.ELSEIF eax == TAB_DELTAB
			invoke TABDelTab
		.ELSEIF eax == EN_KILLFOCUS
			mov d$ [tabBuffer],0
			invoke SendMessage,tab.hEdit,WM_GETTEXT,32,a$ tabBuffer
			.IF b$ [tabBuffer] != 0
				invoke TABGetSel
				imul eax,60
				lea edx, [tabinfos+eax+8]	;text
				mov d$ [edx],0
				invoke szCatStr, edx,a$ tabBuffer
				mov tab.EditFlag,-1
			.ENDIF
			invoke ShowWindow,tab.hEdit,SW_HIDE
			invoke InvalidateRect,tab.hWnd,0,FALSE
		.ELSEIF eax >= TAB_COMMAND1 && eax <= TAB_COMMAND10
			invoke SendMessage,tab.masterhwnd,WM_COMMAND,eax,tab.hWnd
		.ENDIF
	;................................................................
	.ELSEIF msg == WM_NOTIFY										;DONE
		invoke TABToolTipNeedText, lParam
	.ELSE
		invoke DefWindowProc,hwnd,msg,wParam,lParam
		ret
	.ENDIF
	xor eax,eax
	ret
TABWndProc endp

;Cheap but good
TABEditWndProc PROC hEdit:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	mov eax,wParam
	.if al==VK_RETURN
		;keep edit field data
		invoke TABGetSel								;get current item
		push eax
		invoke SendMessage,tab.hWnd,WM_LBUTTONDOWN,0,0	; would select the 1st item
		pop eax
		invoke TABSetSel,eax
	.elseif al==VK_ESCAPE
		;throw away edit field data
		invoke TABGetSel								;get current item
		push eax
		invoke SendMessage,tab.hEdit,WM_SETTEXT,0,0
		invoke SendMessage,tab.hWnd,WM_LBUTTONDOWN,0,0	; would select the 1st item
		pop eax
		invoke TABSetSel,eax
	.else
		invoke CallWindowProc,tab.EditOldWndProc,hEdit,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
TABEditWndProc endp

TABDelAll proc uses ebx

	;deleting all ToolTips
	xor ebx,ebx
	mov ti.cbSize, s$ ti
	m2m ti.hWnd, tab.hWnd
	.WHILE ebx != tab.gentabcount
		mov ti.uId,ebx
		invoke SendMessage,tab.hToolTip,TTM_DELTOOL,0,a$ ti
		inc ebx
	.ENDW
	;reseting everything else
	invoke RtlZeroMemory,a$ tabinfos, 41*60	;(615)
	invoke RtlZeroMemory,a$ tabactive,64
	invoke RtlZeroMemory,a$ tabpos,64
	mov tab.gentabcount,0
	invoke InvalidateRect,tab.hWnd,0,TRUE
	ret
TABDelAll endp

TABPaint proc uses ebx	;ebx == counter for tabs
LOCAL rect:RECT
LOCAL counter:DWORD	
LOCAL old1, old2, old3:DWORD

	.IF tab.gentabcount != 0	; if tab.gentabcount == 0 then there are no tabs
		m2m counter, tab.gentabcount
		;loop thru gentabcount & paint each tab acc. to tabactive
		mov rect.top,0
		m2m rect.bottom, tab.tabheight
		m2m rect.right,tab.tablenght
		mov rect.left,0
		xor ebx,ebx
		.WHILE ebx != counter
			.IF b$ [tabactive+ebx] == 1		; tab is active
				mov old1, $invoke(SelectObject,tab.hdc,tab.hBrush)
				mov old2, $invoke(SelectObject,tab.hdc,tab.hBlackPen)
			.ELSE							; tab is inactive
				mov old1, $invoke(SelectObject,tab.hdc,tab.hLightGrayBrush)
				mov old2, $invoke(SelectObject,tab.hdc,tab.hGrayPen)
			.ENDIF
			mov old3, $invoke(SelectObject,tab.hdc,tab.hTahoma)
			
			invoke Rectangle,tab.hdc,rect.left,rect.top,rect.right,rect.bottom
			.IF tab.SelDC != 0
				.IF b$ [tabactive+ebx] == 1
					mov eax, rect.left
					inc eax
					mov edx,rect.top
					inc edx
					.IF tab.SelDCMask != 0
						push edx
						push eax
						invoke BitBlt,tab.hdc,eax,edx,tab.SelWidth,tab.SelHeight,tab.SelDCMask,0,0,SRCAND
						pop eax
						pop edx
						invoke BitBlt,tab.hdc,eax,edx,tab.SelWidth,tab.SelHeight,tab.SelDC,0,0,SRCPAINT
					.ELSE
						invoke BitBlt,tab.hdc,eax,edx,tab.SelWidth,tab.SelHeight,tab.SelDC,0,0,SRCCOPY
					.ENDIF
				.ENDIF
			.ENDIF
			.IF tab.UnSelDC != 0
				.IF b$ [tabactive+ebx] == 0
					mov eax, rect.left
					inc eax
					mov edx,rect.top
					inc edx
					.IF tab.SelDCMask != 0
						push edx
						push eax
						invoke BitBlt,tab.hdc,eax,edx,tab.SelWidth,tab.SelHeight,tab.UnSelDCMask,0,0,SRCAND
						pop eax
						pop edx
						invoke BitBlt,tab.hdc,eax,edx,tab.SelWidth,tab.SelHeight,tab.UnSelDC,0,0,SRCPAINT
					.ELSE
						invoke BitBlt,tab.hdc,eax,edx,tab.UnSelWidth,tab.UnSelHeight,tab.UnSelDC,0,0,SRCCOPY
					.ENDIF
				.ENDIF
			.ENDIF
			invoke SetBkMode,tab.hdc,TRANSPARENT
			;position the Text
			add rect.top,2
			add rect.left,2+16+4	; 2 space, 16 bmp, 4 space
	
			mov eax,ebx
			imul eax,60	;s$ tabinfos
			lea edx, [tabinfos+eax+8]	;that's where the text is
			invoke DrawText,tab.hdc,edx,-1,a$ rect,DT_LEFT or DT_END_ELLIPSIS or DT_SINGLELINE
			
			;correct our rect again
			sub rect.top,2
			sub rect.left,2+16+4
			
			;set up next tab
			m2m rect.left,rect.right
			add rect.right,$eax(tab.tablenght)
			inc ebx
			
			invoke SelectObject,tab.hdc,old3
			invoke SelectObject,tab.hdc,old2
			invoke SelectObject,tab.hdc,old1
		.ENDW
		mov counter,0
	.ENDIF
	ret
TABPaint endp

TABSetSel proc lParam:DWORD
	
	lea eax, tabactive
	.WHILE b$ [eax] != 1
		inc eax
	.ENDW
	mov b$ [eax],0
	mov eax, lParam
	mov b$ [tabactive+eax],1
	push eax	;save id of tab as return value
	mov ecx, eax
	imul ecx, 60
	mov edx, d$ [tabinfos+ecx+4]	; grab user specific value
	invoke SendMessage,tab.masterhwnd,TAB_SELCHANGED,edx,eax
	pop eax
	ret
TABSetSel endp

TABGetSel proc
	
	lea edx, tabactive
	xor eax,eax
	.WHILE b$ [edx+eax] != 1
		inc eax
	.ENDW
	ret
TABGetSel endp


TABAddTab proc wParam:DWORD, lParam:DWORD
; wParam == extra data from User
; lParam == lpsz to String (if 0 then "NewTab")

	.IF tab.gentabcount > 39
		return TABERR_MAXTABSALLOWED
	.ELSE
		mov eax, tab.gentabcount
		imul eax, 60	;sizeof tabinfos structure
		lea edx,[tabinfos+eax]	; tabinfos+0 == id
		m2m d$ [edx], tab.gentabcount
		add edx,4
		m2m d$ [edx], wParam		; userdata of tab
		add edx,4					; tabinfos+8 == text
		.IF lParam == 0
			;we copy the Text "NewTab" into the tabinfos structure
			push CTXT("New Tab")
		.ELSE
			;we copy the User choosen Text into the Tabinfo structure
			push lParam
		.ENDIF
			mov d$ [edx],0	;make sure the receiving Buffer is empty
			push edx
			call szCatStr
		;set up ToolTip with the Tab
		mov ti.cbSize, s$ ti
		mov ti.uFlags,TTF_SUBCLASS
		m2m ti.hWnd,tab.hWnd
		mov ti.lpszText,LPSTR_TEXTCALLBACK
		m2m ti.rect.bottom,tab.tabheight
		mov eax, tab.gentabcount
		mov ti.uId,eax
		imul eax, tab.tablenght
		mov ti.rect.left,eax
		add eax, tab.tablenght
		mov ti.rect.right,eax
		mov ti.rect.top,0
		invoke SendMessage,tab.hToolTip,TTM_ADDTOOL,0,a$ ti
		mov eax, tab.gentabcount	;return id of tab
		inc tab.gentabcount
	.ENDIF
	invoke TABSetSel,eax	;returns id of selected tab
	ret
TABAddTab endp

;A little weirder because the Tab position can change so the 'imul id*60' doesn't work
;once we delete Tabs. Therefore I have to see where the Cursor is convert it to the id of
;what tab should be there... grab the text and send it home :)
TABToolTipNeedText proc uses ebx lParam:DWORD
LOCAL point:POINT

	.IF tab.ToolTipsFlag == TRUE
		mov eax, lParam
		.IF [eax].TOOLTIPTEXT.hdr.code == TTN_NEEDTEXT
			push eax
			invoke GetCursorPos,a$ point
			invoke ScreenToClient,tab.hWnd,a$ point
			mov eax, point.x
			xor edx,edx
			div $ecx(tab.tablenght)
			;eax got the tab number
			.IF eax == 0
				pop eax
				lea ecx, [tabinfos+8]
				mov [eax].TOOLTIPTEXT.lpszText,ecx
			.ELSEIF eax < tab.gentabcount
				pop edx
				imul eax, 60
				lea ecx, [tabinfos+eax+8]
				mov [edx].TOOLTIPTEXT.lpszText,ecx
			.ENDIF
		.ENDIF
	.ENDIF
	ret
TABToolTipNeedText endp

TABRenTab proc
LOCAL rect:RECT
	
	invoke TABGetSel
   push eax
	imul eax,tab.tablenght
	add eax,2+16+3
	mov rect.left,eax
	mov eax,tab.tablenght
	sub eax,2+16+5
	mov rect.right,eax
	mov rect.right,eax
	mov rect.top,2
	mov eax,tab.tabheight
	sub eax,3
	mov rect.bottom,eax
   pop eax
	imul eax,60
	lea edx,[tabinfos+eax+8]
	invoke SendMessage,tab.hEdit,WM_SETTEXT,0,edx
	invoke MoveWindow,tab.hEdit,rect.left,rect.top,rect.right,rect.bottom,TRUE
	invoke ShowWindow,tab.hEdit,SW_SHOW
	invoke SetFocus,tab.hEdit
	mov tab.EditFlag,1
	ret
TABRenTab endp

TABDelTab proc uses edi esi
	
	;edi pointing to current tab (which we delete)
	;esi pointing to next Tab (which we copy over)
	;no bounds checking when we copy over the current Tab. Reason why there are 41 empty Tabinfos
	;Why? Because if the last Tab gets deleted then the following Tab is empty and would not get
	;copied.
	invoke TABGetSel
	push eax ;***
	mov edx, tab.gentabcount
	dec edx	;after we added one we increase the counter
	sub edx,eax
	.IF edx == 0	;last tab gets deleted
		mov edx,eax
		imul edx,60
		mov eax,0
		lea edi, [tabinfos+edx]
		mov ecx,60/4
		rep movsd
		pop eax ;***
		dec eax	; next selection
	.ELSE	;then it's one of the other tabs...
		imul eax,60	;eax pos of deleted tab
		mov edx,eax
		add edx,60	;edx pos of next tab
		.WHILE b$ [tabinfos+edx+8] != 0	;while there are tabs in the back of it
			lea edi, [tabinfos+eax]
			lea esi, [tabinfos+edx]
			mov ecx,60/4
			rep movsd
			add edx,60
			add eax,60
		.ENDW
		mov edx, tab.gentabcount
		dec edx
		imul edx,60
		mov eax, 0
		lea edi, [tabinfos+edx]
		mov ecx,60/4
		rep movsd
		pop eax ;***
	.ENDIF
	dec tab.gentabcount	; because we just deleted one
	invoke TABSetSel,eax
	invoke InvalidateRect,tab.hWnd,0,TRUE

	ret
TABDelTab endp

TABCreateBrushesAndFonts proc
	
	mov tab.hBrush, 			$invoke(CreateSolidBrush,009EBEB1h)
	mov tab.hLightGrayBrush,	$invoke(CreateSolidBrush,00D7DFDFh)
	mov tab.hBlackPen,			$invoke(CreatePen,PS_SOLID,NULL,0)
	mov tab.hGrayPen,			$invoke(CreatePen,PS_SOLID,NULL,00C3C3C3h)
	mov tab.hTahoma,			$invoke(CreateFontIndirect,a$ TabFont)

	ret
TABCreateBrushesAndFonts endp

TABDeleteBrushesAndFonts proc
	
	.IF tab.UserBrush != TRUE
		invoke DeleteObject,tab.hBrush
		invoke DeleteObject,tab.hLightGrayBrush
	.ENDIF
	.IF tab.UserPen != TRUE
		invoke DeleteObject,tab.hBlackPen
		invoke DeleteObject,tab.hGrayPen
	.ENDIF
	.IF tab.UserFont != TRUE
		invoke DeleteObject,tab.hTahoma
	.ENDIF
	ret
TABDeleteBrushesAndFonts endp


