;
;         PipeDreams
;         written by JimmyClif
;
;         Useful Procedures

;========================================================================
;                           CenterScreen
;========================================================================
;  This little Function centers the main window exactly in the middle of 
;  the screen. Thx to Iczelion!
;========================================================================
CenterScreen proc hwnd:HWND
LOCAL DlgHeight:DWORD
LOCAL DlgWidth:DWORD
LOCAL DlgRect:RECT
LOCAL DesktopRect:RECT
     
     invoke GetWindowRect,hwnd,ADDR DlgRect
     invoke GetDesktopWindow
     mov ecx,eax
     invoke GetWindowRect,ecx,addr DesktopRect
     push 0
     mov eax,DlgRect.bottom
     sub eax,DlgRect.top
     mov DlgHeight,eax
     push eax
     mov eax,DlgRect.right
     sub eax,DlgRect.left
     mov DlgWidth,eax
     push eax
     mov eax,DesktopRect.bottom
     sub eax,DlgHeight
     shr eax,1
     push eax
     mov eax,DesktopRect.right
     sub eax,DlgWidth
     shr eax,1
     push eax
     push hwnd
     call MoveWindow
     ret
CenterScreen endp

;========================================================================
;                           GetCompatibleBitmap
;========================================================================
;  This is used to create DC's for BackBuffers, ImageDC etc...
;  invoke GetCompatibleDC, ADDR ImageDC, ADDR hImageDC, hwnd, 500, 300
;========================================================================
GetCompatibleBitmap proc uses ebx AnotherDC:DWORD, HandleOfDC:DWORD, hwnd:DWORD, xPos:DWORD, yPos:DWORD

     invoke CreateCompatibleDC,NULL
     mov ebx,AnotherDC
     mov dword ptr [ebx],eax     
     invoke GetDC,hwnd
     push eax
     invoke CreateCompatibleBitmap,eax,xPos,yPos
     mov ebx,HandleOfDC
     mov dword ptr [ebx],eax
     pop eax
     invoke ReleaseDC,hwnd,eax
     mov ebx,HandleOfDC
     mov eax,[ebx]
     mov ebx,AnotherDC
     mov ecx,[ebx]
     invoke SelectObject,ecx,eax
     ret
GetCompatibleBitmap endp

;========================================================================
;                           GetBitmapDC
;========================================================================
;  This is used to create DC's for Bitmaps
;  invoke GetBitmapDC, ADDR BitmapDC, ADDR NameOfBitmap, ADDR hBitmap, hwnd
;========================================================================
GetBitmapDC proc uses ebx AnotherDC:DWORD, BitmapADDR:DWORD,HandleOfBitmap:DWORD, hwnd:DWORD

     invoke GetDC,hwnd
     push eax       ;1 push DC for release later
     
     invoke CreateCompatibleDC,eax
     mov ebx,AnotherDC
     mov dword ptr [ebx],eax
     push eax       ;2 push DC for SelectObject
     invoke LoadBitmap,hInstance,BitmapADDR
     mov ebx,HandleOfBitmap
     mov dword ptr [ebx],eax
     pop ecx        ;2 pop Created DC
     invoke SelectObject,ecx,eax
     
     pop eax        ;1 pop DC to release
     invoke ReleaseDC,hwnd,eax
     ret
GetBitmapDC endp
